/[gentoo-x86]/eclass/eutils.eclass
Gentoo

Diff of /eclass/eutils.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.206 Revision 1.223
1# Copyright 1999-2005 Gentoo Foundation 1# Copyright 1999-2005 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.206 2005/10/07 16:21:48 flameeyes Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.223 2006/02/15 23:40:16 flameeyes Exp $
4# 4#
5# Author: Martin Schlemmer <azarah@gentoo.org> 5# Author: Martin Schlemmer <azarah@gentoo.org>
6# 6#
7# This eclass is for general purpose functions that most ebuilds 7# This eclass is for general purpose functions that most ebuilds
8# have to implement themselves. 8# have to implement themselves.
60# to point to the latest version of the library present. 60# to point to the latest version of the library present.
61# 61#
62# <azarah@gentoo.org> (26 Oct 2002) 62# <azarah@gentoo.org> (26 Oct 2002)
63# 63#
64gen_usr_ldscript() { 64gen_usr_ldscript() {
65 local libdir="$(get_libdir)" 65 local lib libdir=$(get_libdir)
66 # Just make sure it exists 66 # Just make sure it exists
67 dodir /usr/${libdir} 67 dodir /usr/${libdir}
68 68
69 for lib in "${@}" ; do 69 for lib in "${@}" ; do
70 cat > "${D}/usr/${libdir}/${lib}" <<-END_LDSCRIPT 70 cat > "${D}/usr/${libdir}/${lib}" <<-END_LDSCRIPT
76 76
77 See bug http://bugs.gentoo.org/4411 for more info. 77 See bug http://bugs.gentoo.org/4411 for more info.
78 */ 78 */
79 GROUP ( /${libdir}/${lib} ) 79 GROUP ( /${libdir}/${lib} )
80 END_LDSCRIPT 80 END_LDSCRIPT
81 fperms a+x "/usr/${libdir}/${lib}" 81 fperms a+x "/usr/${libdir}/${lib}" || die "could not change perms on ${lib}"
82 done 82 done
83} 83}
84 84
85# Simple function to draw a line consisting of '=' the same length as $*
86# - only to be used by epatch()
87#
88# <azarah@gentoo.org> (11 Nov 2002)
89#
90draw_line() {
91 local i=0
92 local str_length=""
93
94 # Handle calls that do not have args, or wc not being installed ...
95 if [ -z "$1" -o ! -x "$(which wc 2>/dev/null)" ]
96 then
97 echo "==============================================================="
98 return 0
99 fi
100
101 # Get the length of $*
102 str_length="$(echo -n "$*" | wc -m)"
103
104 while [ "$i" -lt "${str_length}" ]
105 do
106 echo -n "="
107
108 i=$((i + 1))
109 done
110
111 echo
112
113 return 0
114}
115 85
116# Default directory where patches are located 86# Default directory where patches are located
117EPATCH_SOURCE="${WORKDIR}/patch" 87EPATCH_SOURCE="${WORKDIR}/patch"
118# Default extension for patches 88# Default extension for patches
119EPATCH_SUFFIX="patch.bz2" 89EPATCH_SUFFIX="patch.bz2"
166# hand its a directory, it will set EPATCH_SOURCE to this. 136# hand its a directory, it will set EPATCH_SOURCE to this.
167# 137#
168# <azarah@gentoo.org> (10 Nov 2002) 138# <azarah@gentoo.org> (10 Nov 2002)
169# 139#
170epatch() { 140epatch() {
141 _epatch_draw_line() {
142 local i=0 str_length="" str_out=""
143
144 # Handle calls that do not have args, or wc not being installed ...
145 if [[ -z $1 ]] || ! type -p wc >/dev/null ; then
146 str_length=65
147 else
148 str_length=$(echo -n "$*" | wc -m)
149 fi
150
151 while ((i++ < ${str_length})) ; do
152 str_out="${str_out}="
153 done
154 echo ${str_out}
155
156 return 0
157 }
158 _epatch_assert() { local _pipestatus=${PIPESTATUS[*]}; [[ ${_pipestatus// /} -eq 0 ]] ; }
171 local PIPE_CMD="" 159 local PIPE_CMD=""
172 local STDERR_TARGET="${T}/$$.out" 160 local STDERR_TARGET="${T}/$$.out"
173 local PATCH_TARGET="${T}/$$.patch" 161 local PATCH_TARGET="${T}/$$.patch"
174 local PATCH_SUFFIX="" 162 local PATCH_SUFFIX=""
175 local SINGLE_PATCH="no" 163 local SINGLE_PATCH="no"
284 272
285 # Allow for prefix to differ ... im lazy, so shoot me :/ 273 # Allow for prefix to differ ... im lazy, so shoot me :/
286 while [ "${count}" -lt 5 ] 274 while [ "${count}" -lt 5 ]
287 do 275 do
288 # Generate some useful debug info ... 276 # Generate some useful debug info ...
289 draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 277 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
290 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 278 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
291 279
292 if [ "${PATCH_SUFFIX}" != "patch" ] 280 if [ "${PATCH_SUFFIX}" != "patch" ]
293 then 281 then
294 echo -n "PIPE_COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 282 echo -n "PIPE_COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
299 287
300 echo -n "PATCH COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 288 echo -n "PATCH COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
301 echo "patch -p${count} ${popts} < ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 289 echo "patch -p${count} ${popts} < ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
302 290
303 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 291 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
304 draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 292 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
305 293
306 if [ "${PATCH_SUFFIX}" != "patch" ] 294 if [ "${PATCH_SUFFIX}" != "patch" ]
307 then 295 then
308 if ! (${PIPE_CMD} ${x} > ${PATCH_TARGET}) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1 296 if ! (${PIPE_CMD} ${x} > ${PATCH_TARGET}) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
309 then 297 then
313 count=5 301 count=5
314 break 302 break
315 fi 303 fi
316 fi 304 fi
317 305
318 if (cat ${PATCH_TARGET} | patch -p${count} ${popts} --dry-run -f) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1 306 if (cat ${PATCH_TARGET} | patch -p${count} ${popts} --dry-run -f ; _epatch_assert) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
319 then 307 then
320 draw_line "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 308 _epatch_draw_line "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
321 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 309 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
322 echo "ACTUALLY APPLYING ${patchname} ..." >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 310 echo "ACTUALLY APPLYING ${patchname} ..." >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
323 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 311 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
324 draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 312 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
325 313
326 cat ${PATCH_TARGET} | patch -p${count} ${popts} >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 2>&1 314 cat ${PATCH_TARGET} | patch -p${count} ${popts} >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 2>&1
315 _epatch_assert
327 316
328 if [ "$?" -ne 0 ] 317 if [ "$?" -ne 0 ]
329 then 318 then
330 cat ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 319 cat ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
331 echo 320 echo
394 tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM} 383 tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM}
395 done 384 done
396 ${exe} "${tmp}" || ${exe} -p "${tmp}" 385 ${exe} "${tmp}" || ${exe} -p "${tmp}"
397 echo "${tmp}" 386 echo "${tmp}"
398 else 387 else
399 [[ ${exe} == "touch" ]] \ 388 if [[ ${exe} == "touch" ]] ; then
389 [[ ${USERLAND} == "GNU" ]] \
400 && exe="-p" \ 390 && exe="-p" \
391 || exe="-t"
392 else
393 [[ ${USERLAND} == "GNU" ]] \
394 && exe="-d" \
401 || exe="-d" 395 || exe="-dt"
402 mktemp ${exe} "${topdir}" 396 fi
397 TMPDIR="${topdir}" mktemp ${exe} tmp
403 fi 398 fi
404} 399}
405 400
406# Small wrapper for getent (Linux), nidump (Mac OS X), 401# Small wrapper for getent (Linux), nidump (Mac OS X),
407# and pw (FreeBSD) used in enewuser()/enewgroup() 402# and pw (FreeBSD) used in enewuser()/enewgroup()
419 *) # Numeric 414 *) # Numeric
420 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }" 415 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }"
421 ;; 416 ;;
422 esac 417 esac
423 ;; 418 ;;
424 *-freebsd*) 419 *-freebsd*|*-dragonfly*)
425 local opts action="user" 420 local opts action="user"
426 [[ $1 == "passwd" ]] || action="group" 421 [[ $1 == "passwd" ]] || action="group"
427 422
428 # lookup by uid/gid 423 # lookup by uid/gid
429 if [[ $2 == [[:digit:]]* ]] ; then 424 if [[ $2 == [[:digit:]]* ]] ; then
430 [[ ${action} == "user" ]] && opts="-u" || opts="-g" 425 [[ ${action} == "user" ]] && opts="-u" || opts="-g"
431 fi 426 fi
432 427
433 pw show ${action} ${opts} "$2" -q 428 pw show ${action} ${opts} "$2" -q
434 ;; 429 ;;
435 *-netbsd*) 430 *-netbsd*|*-openbsd*)
436 grep "$2:\*:" /etc/$1 431 grep "$2:\*:" /etc/$1
437 ;; 432 ;;
438 *) 433 *)
439 type -p nscd >& /dev/null && nscd -i "$1" 434 type -p nscd >& /dev/null && nscd -i "$1"
440 getent "$1" "$2" 435 getent "$1" "$2"
495 einfo " - Userid: ${euid}" 490 einfo " - Userid: ${euid}"
496 491
497 # handle shell 492 # handle shell
498 local eshell=$1; shift 493 local eshell=$1; shift
499 if [[ ! -z ${eshell} ]] && [[ ${eshell} != "-1" ]] ; then 494 if [[ ! -z ${eshell} ]] && [[ ${eshell} != "-1" ]] ; then
500 if [[ ! -e ${eshell} ]] ; then 495 if [[ ! -e ${ROOT}${eshell} ]] ; then
501 eerror "A shell was specified but it does not exist !" 496 eerror "A shell was specified but it does not exist !"
502 die "${eshell} does not exist" 497 die "${eshell} does not exist in ${ROOT}"
498 fi
499 if [[ ${eshell} == */false || ${eshell} == */nologin ]] ; then
500 eerror "Do not specify ${eshell} yourself, use -1"
501 die "Pass '-1' as the shell parameter"
503 fi 502 fi
504 else 503 else
505 for shell in /sbin/nologin /usr/sbin/nologin /bin/false /usr/bin/false /dev/null ; do 504 for shell in /sbin/nologin /usr/sbin/nologin /bin/false /usr/bin/false /dev/null ; do
506 [[ -x ${ROOT}${shell} ]] && break 505 [[ -x ${ROOT}${shell} ]] && break
507 done 506 done
578 einfo "Please report the ebuild along with the info below" 577 einfo "Please report the ebuild along with the info below"
579 einfo "eextra: $@" 578 einfo "eextra: $@"
580 die "Required function missing" 579 die "Required function missing"
581 fi 580 fi
582 ;; 581 ;;
583 *-freebsd*) 582 *-freebsd*|*-dragonfly*)
584 if [[ -z $@ ]] ; then 583 if [[ -z $@ ]] ; then
585 pw useradd ${euser} ${opts} \ 584 pw useradd ${euser} ${opts} \
586 -c "added by portage for ${PN}" \ 585 -c "added by portage for ${PN}" \
587 die "enewuser failed" 586 die "enewuser failed"
588 else 587 else
589 einfo " - Extra: $@" 588 einfo " - Extra: $@"
590 pw useradd ${euser} ${opts} \ 589 pw useradd ${euser} ${opts} \
591 "$@" || die "enewuser failed" 590 "$@" || die "enewuser failed"
592 fi 591 fi
593 ;; 592 ;;
593
594 *-netbsd*)
595 if [[ -z $@ ]] ; then
596 useradd ${opts} ${euser} || die "enewuser failed"
597 else
598 einfo " - Extra: $@"
599 useradd ${opts} ${euser} "$@" || die "enewuser failed"
600 fi
601 ;;
602
603 *-openbsd*)
604 if [[ -z $@ ]] ; then
605 useradd -u ${euid} -s ${eshell} \
606 -d ${ehome} -c "Added by portage for ${PN}" \
607 -g ${egroups} ${euser} || die "enewuser failed"
608 else
609 einfo " - Extra: $@"
610 useradd -u ${euid} -s ${eshell} \
611 -d ${ehome} -c "Added by portage for ${PN}" \
612 -g ${egroups} ${euser} "$@" || die "enewuser failed"
613 fi
614 ;;
615
594 *) 616 *)
595 if [[ -z $@ ]] ; then 617 if [[ -z $@ ]] ; then
596 useradd ${opts} ${euser} \ 618 useradd ${opts} ${euser} \
597 -c "added by portage for ${PN}" \ 619 -c "added by portage for ${PN}" \
598 || die "enewuser failed" 620 || die "enewuser failed"
693 esac 715 esac
694 dscl . create /groups/${egroup} gid ${egid} 716 dscl . create /groups/${egroup} gid ${egid}
695 dscl . create /groups/${egroup} passwd '*' 717 dscl . create /groups/${egroup} passwd '*'
696 ;; 718 ;;
697 719
698 *-freebsd*) 720 *-freebsd*|*-dragonfly*)
699 case ${egid} in 721 case ${egid} in
700 *[!0-9]*) # Non numeric 722 *[!0-9]*) # Non numeric
701 for egid in $(seq 101 999); do 723 for egid in $(seq 101 999); do
702 [ -z "`egetent group ${egid}`" ] && break 724 [ -z "`egetent group ${egid}`" ] && break
703 done 725 done
710 *[!0-9]*) # Non numeric 732 *[!0-9]*) # Non numeric
711 for egid in $(seq 101 999); do 733 for egid in $(seq 101 999); do
712 [ -z "`egetent group ${egid}`" ] && break 734 [ -z "`egetent group ${egid}`" ] && break
713 done 735 done
714 esac 736 esac
715 groupadd ${egroup} -g ${egid} || die "enewgroup failed" 737 groupadd -g ${egid} ${egroup} || die "enewgroup failed"
716 ;; 738 ;;
717 739
718 *) 740 *)
719 groupadd ${opts} ${egroup} || die "enewgroup failed" 741 groupadd ${opts} ${egroup} || die "enewgroup failed"
720 ;; 742 ;;
837 type="Network;${type}" 859 type="Network;${type}"
838 ;; 860 ;;
839 861
840 sci) 862 sci)
841 case ${catmin} in 863 case ${catmin} in
842 astro*) type=Astronomoy;; 864 astro*) type=Astronomy;;
843 bio*) type=Biology;; 865 bio*) type=Biology;;
844 calc*) type=Calculator;; 866 calc*) type=Calculator;;
845 chem*) type=Chemistry;; 867 chem*) type=Chemistry;;
846 geo*) type=Geology;; 868 geo*) type=Geology;;
847 math*) type=Math;; 869 math*) type=Math;;
999 local sizeoff_t=$2 1021 local sizeoff_t=$2
1000 1022
1001 [[ -z ${src} ]] && die "Could not locate source for '$1'" 1023 [[ -z ${src} ]] && die "Could not locate source for '$1'"
1002 [[ -z ${sizeoff_t} ]] && die "No idea what off_t size was used for this pdv :(" 1024 [[ -z ${sizeoff_t} ]] && die "No idea what off_t size was used for this pdv :("
1003 1025
1004 local shrtsrc="`basename ${src}`" 1026 local shrtsrc=$(basename "${src}")
1005 echo ">>> Unpacking ${shrtsrc} to ${PWD}" 1027 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1006 local metaskip=`tail -c ${sizeoff_t} ${src} | hexdump -e \"%i\"` 1028 local metaskip=`tail -c ${sizeoff_t} ${src} | hexdump -e \"%i\"`
1007 local tailskip=`tail -c $((${sizeoff_t}*2)) ${src} | head -c ${sizeoff_t} | hexdump -e \"%i\"` 1029 local tailskip=`tail -c $((${sizeoff_t}*2)) ${src} | head -c ${sizeoff_t} | hexdump -e \"%i\"`
1008 1030
1009 # grab metadata for debug reasons 1031 # grab metadata for debug reasons
1073# Usage: unpack_makeself [file to unpack] [offset] [tail|dd] 1095# Usage: unpack_makeself [file to unpack] [offset] [tail|dd]
1074# - If the file is not specified then unpack will utilize ${A}. 1096# - If the file is not specified then unpack will utilize ${A}.
1075# - If the offset is not specified then we will attempt to extract 1097# - If the offset is not specified then we will attempt to extract
1076# the proper offset from the script itself. 1098# the proper offset from the script itself.
1077unpack_makeself() { 1099unpack_makeself() {
1100 local src_input=${1:-${A}}
1078 local src=$(find_unpackable_file "$1") 1101 local src=$(find_unpackable_file "${src_input}")
1079 local skip=$2 1102 local skip=$2
1080 local exe=$3 1103 local exe=$3
1081 1104
1082 [[ -z ${src} ]] && die "Could not locate source for '$1'" 1105 [[ -z ${src} ]] && die "Could not locate source for '${src_input}'"
1083 1106
1084 local shrtsrc=$(basename "${src}") 1107 local shrtsrc=$(basename "${src}")
1085 echo ">>> Unpacking ${shrtsrc} to ${PWD}" 1108 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1086 if [ -z "${skip}" ] 1109 if [[ -z ${skip} ]] ; then
1087 then
1088 local ver="`grep -a '#.*Makeself' ${src} | awk '{print $NF}'`" 1110 local ver=$(grep -a '#.*Makeself' "${src}" | awk '{print $NF}')
1089 local skip=0 1111 local skip=0
1090 exe=tail 1112 exe=tail
1091 case ${ver} in 1113 case ${ver} in
1092 1.5.*) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same 1114 1.5.*) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same
1093 skip=$(grep -a ^skip= "${src}" | cut -d= -f2) 1115 skip=$(grep -a ^skip= "${src}" | cut -d= -f2)
1105 ;; 1127 ;;
1106 2.1.3) 1128 2.1.3)
1107 skip=`grep -a ^offset= "${src}" | awk '{print $3}'` 1129 skip=`grep -a ^offset= "${src}" | awk '{print $3}'`
1108 let skip="skip + 1" 1130 let skip="skip + 1"
1109 ;; 1131 ;;
1110 2.1.4) 1132 2.1.4|2.1.5)
1111 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1) 1133 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1)
1112 skip=$(head -n ${skip} "${src}" | wc -c) 1134 skip=$(head -n ${skip} "${src}" | wc -c)
1113 exe="dd" 1135 exe="dd"
1114 ;; 1136 ;;
1115 *) 1137 *)
1234 # first we figure out how many cds we're dealing with by 1256 # first we figure out how many cds we're dealing with by
1235 # the # of files they gave us 1257 # the # of files they gave us
1236 local cdcnt=0 1258 local cdcnt=0
1237 local f= 1259 local f=
1238 for f in "$@" ; do 1260 for f in "$@" ; do
1239 cdcnt=$((cdcnt + 1)) 1261 ((++cdcnt))
1240 export CDROM_CHECK_${cdcnt}="$f" 1262 export CDROM_CHECK_${cdcnt}="$f"
1241 done 1263 done
1242 export CDROM_TOTAL_CDS=${cdcnt} 1264 export CDROM_TOTAL_CDS=${cdcnt}
1243 export CDROM_CURRENT_CD=1 1265 export CDROM_CURRENT_CD=1
1244 1266
1245 # now we see if the user gave use CD_ROOT ... 1267 # now we see if the user gave use CD_ROOT ...
1246 # if they did, let's just believe them that it's correct 1268 # if they did, let's just believe them that it's correct
1247 if [[ ! -z ${CD_ROOT} ]] ; then
1248 export CDROM_ROOT=${CD_ROOT}
1249 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1250 return
1251 fi
1252 # do the same for CD_ROOT_X
1253 if [[ ! -z ${CD_ROOT_1} ]] ; then 1269 if [[ -n ${CD_ROOT}${CD_ROOT_1} ]] ; then
1254 local var= 1270 local var=
1255 cdcnt=0 1271 cdcnt=0
1256 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do 1272 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1257 cdcnt=$((cdcnt + 1)) 1273 ((++cdcnt))
1258 var="CD_ROOT_${cdcnt}" 1274 var="CD_ROOT_${cdcnt}"
1275 [[ -z ${!var} ]] && var="CD_ROOT"
1259 if [[ -z ${!var} ]] ; then 1276 if [[ -z ${!var} ]] ; then
1260 eerror "You must either use just the CD_ROOT" 1277 eerror "You must either use just the CD_ROOT"
1261 eerror "or specify ALL the CD_ROOT_X variables." 1278 eerror "or specify ALL the CD_ROOT_X variables."
1262 eerror "In this case, you will need ${CDROM_TOTAL_CDS} CD_ROOT_X variables." 1279 eerror "In this case, you will need ${CDROM_TOTAL_CDS} CD_ROOT_X variables."
1263 die "could not locate CD_ROOT_${cdcnt}" 1280 die "could not locate CD_ROOT_${cdcnt}"
1264 fi 1281 fi
1265 export CDROM_ROOTS_${cdcnt}="${!var}"
1266 done 1282 done
1267 export CDROM_ROOT=${CDROM_ROOTS_1} 1283 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}}
1268 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}" 1284 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1285 export CDROM_SET=-1
1286 for f in ${CDROM_CHECK_1//:/ } ; do
1287 ((++CDROM_SET))
1288 [[ -e ${CD_ROOT}/${f} ]] && break
1289 done
1290 export CDROM_MATCH=${f}
1269 return 1291 return
1270 fi 1292 fi
1271 1293
1294 # User didn't help us out so lets make sure they know they can
1295 # simplify the whole process ...
1272 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then 1296 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then
1273 einfon "This ebuild will need the " 1297 einfo "This ebuild will need the ${CDROM_NAME:-cdrom for ${PN}}"
1274 if [[ -z ${CDROM_NAME} ]] ; then
1275 echo "cdrom for ${PN}."
1276 else
1277 echo "${CDROM_NAME}."
1278 fi
1279 echo 1298 echo
1280 einfo "If you do not have the CD, but have the data files" 1299 einfo "If you do not have the CD, but have the data files"
1281 einfo "mounted somewhere on your filesystem, just export" 1300 einfo "mounted somewhere on your filesystem, just export"
1282 einfo "the variable CD_ROOT so that it points to the" 1301 einfo "the variable CD_ROOT so that it points to the"
1283 einfo "directory containing the files." 1302 einfo "directory containing the files."
1287 echo 1306 echo
1288 else 1307 else
1289 einfo "This package will need access to ${CDROM_TOTAL_CDS} cds." 1308 einfo "This package will need access to ${CDROM_TOTAL_CDS} cds."
1290 cdcnt=0 1309 cdcnt=0
1291 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do 1310 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1292 cdcnt=$((cdcnt + 1)) 1311 ((++cdcnt))
1293 var="CDROM_NAME_${cdcnt}" 1312 var="CDROM_NAME_${cdcnt}"
1294 [[ ! -z ${!var} ]] && einfo " CD ${cdcnt}: ${!var}" 1313 [[ ! -z ${!var} ]] && einfo " CD ${cdcnt}: ${!var}"
1295 done 1314 done
1296 echo 1315 echo
1297 einfo "If you do not have the CDs, but have the data files" 1316 einfo "If you do not have the CDs, but have the data files"
1298 einfo "mounted somewhere on your filesystem, just export" 1317 einfo "mounted somewhere on your filesystem, just export"
1299 einfo "the following variables so they point to the right place:" 1318 einfo "the following variables so they point to the right place:"
1300 einfon "" 1319 einfon ""
1301 cdcnt=0 1320 cdcnt=0
1302 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do 1321 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1303 cdcnt=$((cdcnt + 1)) 1322 ((++cdcnt))
1304 echo -n " CD_ROOT_${cdcnt}" 1323 echo -n " CD_ROOT_${cdcnt}"
1305 done 1324 done
1306 echo 1325 echo
1307 einfo "Or, if you have all the files in the same place, or" 1326 einfo "Or, if you have all the files in the same place, or"
1308 einfo "you only have one cdrom, you can export CD_ROOT" 1327 einfo "you only have one cdrom, you can export CD_ROOT"
1311 echo 1330 echo
1312 einfo "For example:" 1331 einfo "For example:"
1313 einfo "export CD_ROOT_1=/mnt/cdrom" 1332 einfo "export CD_ROOT_1=/mnt/cdrom"
1314 echo 1333 echo
1315 fi 1334 fi
1335
1336 export CDROM_SET=""
1316 export CDROM_CURRENT_CD=0 1337 export CDROM_CURRENT_CD=0
1317 cdrom_load_next_cd 1338 cdrom_load_next_cd
1318} 1339}
1319 1340
1320# this is only used when you need access to more than one cd. 1341# this is only used when you need access to more than one cd.
1321# when you have finished using the first cd, just call this function. 1342# when you have finished using the first cd, just call this function.
1322# when it returns, CDROM_ROOT will be pointing to the second cd. 1343# when it returns, CDROM_ROOT will be pointing to the second cd.
1323# remember, you can only go forward in the cd chain, you can't go back. 1344# remember, you can only go forward in the cd chain, you can't go back.
1324cdrom_load_next_cd() { 1345cdrom_load_next_cd() {
1325 export CDROM_CURRENT_CD=$((CDROM_CURRENT_CD + 1))
1326 local var= 1346 local var
1327 1347 ((++CDROM_CURRENT_CD))
1328 if [[ ! -z ${CD_ROOT} ]] ; then
1329 einfo "Using same root as before for CD #${CDROM_CURRENT_CD}"
1330 return
1331 fi
1332 1348
1333 unset CDROM_ROOT 1349 unset CDROM_ROOT
1334 var=CDROM_ROOTS_${CDROM_CURRENT_CD} 1350 var=CD_ROOT_${CDROM_CURRENT_CD}
1351 [[ -z ${!var} ]] && var="CD_ROOT"
1335 if [[ -z ${!var} ]] ; then 1352 if [[ -z ${!var} ]] ; then
1336 var="CDROM_CHECK_${CDROM_CURRENT_CD}" 1353 var="CDROM_CHECK_${CDROM_CURRENT_CD}"
1337 cdrom_locate_file_on_cd ${!var} 1354 _cdrom_locate_file_on_cd ${!var}
1338 else 1355 else
1339 export CDROM_ROOT=${!var} 1356 export CDROM_ROOT=${!var}
1340 fi 1357 fi
1341 1358
1342 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}" 1359 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1347# all it does is try to locate a give file on a cd ... if the cd isn't 1364# all it does is try to locate a give file on a cd ... if the cd isn't
1348# found, then a message asking for the user to insert the cdrom will be 1365# found, then a message asking for the user to insert the cdrom will be
1349# displayed and we'll hang out here until: 1366# displayed and we'll hang out here until:
1350# (1) the file is found on a mounted cdrom 1367# (1) the file is found on a mounted cdrom
1351# (2) the user hits CTRL+C 1368# (2) the user hits CTRL+C
1352cdrom_locate_file_on_cd() { 1369_cdrom_locate_file_on_cd() {
1370 local mline=""
1371 local showedmsg=0
1372
1353 while [[ -z ${CDROM_ROOT} ]] ; do 1373 while [[ -z ${CDROM_ROOT} ]] ; do
1354 local dir=$(dirname "$*") 1374 local i=0
1375 local -a cdset=(${*//:/ })
1376 if [[ -n ${CDROM_SET} ]] ; then
1377 cdset=(${cdset[${CDROM_SET}]})
1378 fi
1379
1380 while [[ -n ${cdset[${i}]} ]] ; do
1381 local dir=$(dirname ${cdset[${i}]})
1355 local file=$(basename "$*") 1382 local file=$(basename ${cdset[${i}]})
1356 local mline=""
1357 local showedmsg=0
1358 1383
1359 for mline in $(mount | egrep -e '(iso|cdrom)' | awk '{print $3}') ; do 1384 for mline in $(mount | gawk '/(iso|cdrom|fs=cdfss)/ {print $3}') ; do
1360 [[ -d ${mline}/${dir} ]] || continue 1385 [[ -d ${mline}/${dir} ]] || continue
1361 [[ ! -z $(find ${mline}/${dir} -maxdepth 1 -iname ${file}) ]] \ 1386 if [[ -n $(find ${mline}/${dir} -maxdepth 1 -iname ${file}) ]] ; then
1362 && export CDROM_ROOT=${mline} 1387 export CDROM_ROOT=${mline}
1388 export CDROM_SET=${i}
1389 export CDROM_MATCH=${cdset[${i}]}
1390 return
1391 fi
1392 done
1393
1394 ((++i))
1363 done 1395 done
1364 1396
1365 if [[ -z ${CDROM_ROOT} ]] ; then
1366 echo 1397 echo
1367 if [[ ${showedmsg} -eq 0 ]] ; then 1398 if [[ ${showedmsg} -eq 0 ]] ; then
1368 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then 1399 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then
1369 if [[ -z ${CDROM_NAME} ]] ; then 1400 if [[ -z ${CDROM_NAME} ]] ; then
1370 einfo "Please insert the cdrom for ${PN} now !" 1401 einfo "Please insert+mount the cdrom for ${PN} now !"
1371 else
1372 einfo "Please insert the ${CDROM_NAME} cdrom now !"
1373 fi
1374 else 1402 else
1375 if [[ -z ${CDROM_NAME_1} ]] ; then
1376 einfo "Please insert cd #${CDROM_CURRENT_CD} for ${PN} now !"
1377 else
1378 local var="CDROM_NAME_${CDROM_CURRENT_CD}"
1379 einfo "Please insert+mount the ${!var} cdrom now !" 1403 einfo "Please insert+mount the ${CDROM_NAME} cdrom now !"
1380 fi
1381 fi 1404 fi
1382 showedmsg=1 1405 else
1406 if [[ -z ${CDROM_NAME_1} ]] ; then
1407 einfo "Please insert+mount cd #${CDROM_CURRENT_CD} for ${PN} now !"
1408 else
1409 local var="CDROM_NAME_${CDROM_CURRENT_CD}"
1410 einfo "Please insert+mount the ${!var} cdrom now !"
1411 fi
1383 fi 1412 fi
1413 showedmsg=1
1414 fi
1384 einfo "Press return to scan for the cd again" 1415 einfo "Press return to scan for the cd again"
1385 einfo "or hit CTRL+C to abort the emerge." 1416 einfo "or hit CTRL+C to abort the emerge."
1386 echo 1417 echo
1387 einfo "If you are having trouble with the detection" 1418 einfo "If you are having trouble with the detection"
1388 einfo "of your CD, it is possible that you do not have" 1419 einfo "of your CD, it is possible that you do not have"
1389 einfo "Joliet support enabled in your kernel. Please" 1420 einfo "Joliet support enabled in your kernel. Please"
1390 einfo "check that CONFIG_JOLIET is enabled in your kernel." 1421 einfo "check that CONFIG_JOLIET is enabled in your kernel."
1391 read 1422 read || die "something is screwed with your system"
1392 fi
1393 done 1423 done
1394} 1424}
1395 1425
1396# Make sure that LINGUAS only contains languages that 1426# Make sure that LINGUAS only contains languages that
1397# a package can support 1427# a package can support
1545 [[ ${opt:0:1} = "-" ]] && shift || opt="-a" 1575 [[ ${opt:0:1} = "-" ]] && shift || opt="-a"
1546 1576
1547 local PKG=$(best_version $1) 1577 local PKG=$(best_version $1)
1548 shift 1578 shift
1549 1579
1550 local USEFILE="${ROOT}/var/db/pkg/${PKG}/USE" 1580 local USEFILE=${ROOT}/var/db/pkg/${PKG}/USE
1581
1582 # if the USE file doesnt exist, assume the $PKG is either
1583 # injected or package.provided
1551 [[ ! -e ${USEFILE} ]] && return 1 1584 [[ ! -e ${USEFILE} ]] && return 0
1552 1585
1553 local USE_BUILT=$(<${USEFILE}) 1586 local USE_BUILT=$(<${USEFILE})
1554 while [[ $# -gt 0 ]] ; do 1587 while [[ $# -gt 0 ]] ; do
1555 if [[ ${opt} = "-o" ]] ; then 1588 if [[ ${opt} = "-o" ]] ; then
1556 has $1 ${USE_BUILT} && return 0 1589 has $1 ${USE_BUILT} && return 0
1613 # We don't want to quote ${bin} so that people can pass complex 1646 # We don't want to quote ${bin} so that people can pass complex
1614 # things as $bin ... "./someprog --args" 1647 # things as $bin ... "./someprog --args"
1615 cat << EOF > "${tmpwrapper}" 1648 cat << EOF > "${tmpwrapper}"
1616#!/bin/sh 1649#!/bin/sh
1617cd "${chdir:-.}" 1650cd "${chdir:-.}"
1651if [ -n "${libdir}" ] ; then
1618if [ "\${LD_LIBRARY_PATH+set}" = "set" ] && [ -n "${libdir}" ] ; then 1652 if [ "\${LD_LIBRARY_PATH+set}" = "set" ] ; then
1619 export LD_LIBRARY_PATH="\${LD_LIBRARY_PATH}:${libdir}" 1653 export LD_LIBRARY_PATH="\${LD_LIBRARY_PATH}:${libdir}"
1654 else
1655 export LD_LIBRARY_PATH="${libdir}"
1656 fi
1620fi 1657fi
1621exec ${bin} "\$@" 1658exec ${bin} "\$@"
1622EOF 1659EOF
1623 chmod go+rx "${tmpwrapper}" 1660 chmod go+rx "${tmpwrapper}"
1624 if [[ -n ${path} ]] ; then 1661 if [[ -n ${path} ]] ; then

Legend:
Removed from v.1.206  
changed lines
  Added in v.1.223

  ViewVC Help
Powered by ViewVC 1.1.20